package com.bbc.denadrive.apihandlers

import android.util.Log
import androidx.compose.runtime.MutableState
import androidx.compose.runtime.mutableStateOf
//import androidx.lifecycle.LiveData
//import androidx.lifecycle.MutableLiveData
import androidx.lifecycle.ViewModel
import kotlinx.serialization.SerializationException
import kotlinx.serialization.json.Json

class ResponsesHandler: ViewModel() {

//    private val _lastResponseBody = MutableLiveData<DriveResponseBody?>(null)
//    val lastResponseBody: LiveData<DriveResponseBody?> get() = _lastResponseBody
    val lastResponseBody: MutableState<DriveResponseBody?> = mutableStateOf(null)

    private var lastResponse: String = ""
    private var isComplete: Boolean = true
    private lateinit var respBuilder: StringBuilder

    fun newResponseArrived(response: String?) {
        if (isComplete && response != null) {
            respBuilder = StringBuilder(response)
            updateCompleteness()
            Log.e("OLE", "newResponseArrived: $response")
        }
        else if (response != null) {
            respBuilder.append(response)
            Log.e("OLE2", "newResponseArrived: $response")
            updateCompleteness()
        }
    }

    private fun checkForCompleteness(): Pair<Boolean, DriveResponseBody?> {
        return try {
            Log.e("ASSURDO", "newResponseArrived: $respBuilder")
            Pair(true, Json.decodeFromString<DriveResponseBody>(respBuilder.toString()))
        } catch (e: SerializationException) {
            Log.e("EDECCOCE", "newResponseArrived: $respBuilder")
            Log.e("EDECCOCE", "errore: ${e.cause}")
            Log.e("EDECCOCE", "errore: ${e.message}")
            Pair(false, null)
        }
    }

    private fun updateCompleteness() {
        val pair = checkForCompleteness()
        isComplete = pair.first
        if (isComplete) {
            lastResponse = respBuilder.toString()
            Log.e("NONSOCHESUCCEDA", "${pair.second}", )
            lastResponseBody.value = pair.second
        }
    }

}